coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH 1/6] test: expose recent gnulib canonicalize bug


From: Eric Blake
Subject: [PATCH 1/6] test: expose recent gnulib canonicalize bug
Date: Wed, 14 Mar 2012 14:38:12 -0600

https://lists.gnu.org/archive/html/bug-gnulib/2012-02/msg00038.html
detailed a couple of bugs in gnulib's canonicalize that were visible
through coreutils' readlink, but only on systems where // is distinct
from /.  This particular test assumes the POSIX fix which requires
canonicalization of a symlink containing just slashes to behave as
if slashes separating the symlink from the rest of the name are
elided (see http://austingroupbugs.net/view.php?id=541), as that is
the only useful (and current) behavior on Cygwin.  That is,

ln -s / root
ls root/dev

must list the contents of /dev, not //dev.

* tests/misc/readlink-root: New test.
* tests/Makefile.am (TESTS): Run it.
---
 tests/Makefile.am        |    1 +
 tests/misc/readlink-root |   92 ++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 93 insertions(+), 0 deletions(-)
 create mode 100755 tests/misc/readlink-root

diff --git a/tests/Makefile.am b/tests/Makefile.am
index c25d4e8..c72b175 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -220,6 +220,7 @@ TESTS =                                             \
   misc/printf-surprise                         \
   misc/pwd-long                                        \
   misc/readlink-fp-loop                                \
+  misc/readlink-root                           \
   misc/realpath                                        \
   misc/runcon-no-reorder                       \
   misc/sha1sum                                 \
diff --git a/tests/misc/readlink-root b/tests/misc/readlink-root
new file mode 100755
index 0000000..f69bad6
--- /dev/null
+++ b/tests/misc/readlink-root
@@ -0,0 +1,92 @@
+#!/bin/sh
+# tests for canonicalize-existing mode (readlink -e) on /.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ readlink
+
+stat_single=$(stat -c %d:%i /) || framework_failure_
+stat_double=$(stat -c %d:%i //) || framework_failure_
+double_slash=//
+if test x"$stat_single" = x"$stat_double"; then
+  double_slash=/
+fi
+
+test -d /dev || framework_failure_
+
+ln -s / one || framework_failure_
+ln -s // two || framework_failure_
+ln -s /// three || framework_failure_
+ln -s /./..// one-dots || framework_failure_
+ln -s //./..// two-dots || framework_failure_
+ln -s ///./..// three-dots || framework_failure_
+ln -s /dev one-dev || framework_failure_
+ln -s //dev two-dev || framework_failure_
+ln -s ///dev three-dev || framework_failure_
+
+cat >exp <<EOF || framework_failure_
+/
+$double_slash
+/
+/
+$double_slash
+/
+/
+$double_slash
+/
+/
+$double_slash
+/
+/dev
+${double_slash}dev
+/dev
+/dev
+${double_slash}dev
+/dev
+/dev
+${double_slash}dev
+/dev
+EOF
+
+{
+  readlink -e / || fail=1
+  readlink -e // || fail=1
+  readlink -e /// || fail=1
+  readlink -e /.//.. || fail=1
+  readlink -e //.//.. || fail=1
+  readlink -e ///.//.. || fail=1
+  readlink -e one || fail=1
+  readlink -e two || fail=1
+  readlink -e three || fail=1
+  readlink -e one-dots || fail=1
+  readlink -e two-dots || fail=1
+  readlink -e three-dots || fail=1
+  readlink -e one-dev || fail=1
+  # We know /dev exists, but cannot assume //dev exists
+  readlink -f two-dev || fail=1
+  readlink -e three-dev || fail=1
+  readlink -e one/dev || fail=1
+  readlink -f two/dev || fail=1
+  readlink -e three/dev || fail=1
+  readlink -e one-dots/dev || fail=1
+  readlink -f two-dots/dev || fail=1
+  readlink -e three-dots/dev || fail=1
+} > out
+
+compare exp out || fail=1
+
+Exit $fail
-- 
1.7.7.6




reply via email to

[Prev in Thread] Current Thread [Next in Thread]